function GameState() {
	this.money = 100
	this.cars_fixed = 0
	this.enginebay = undefined
	this.current_procedure = []
	this.current_material_cost = 0
	this.current_work_cost = 0
	this.known_procedures = {}
	this.global_part_appearance_chance = 1.0
	this.part_chances = {}
	for(var partname in part_library){
		this.part_chances[partname] = 1.0
	}

	this.customer_partnames = []
	this.add_customer_partname = function(){
		var partname = all_partnames[
				Math.floor(Math.random() * all_partnames.length)]
		console.log("Adding possible customer partname: "+partname)
		this.customer_partnames.push(partname)
	}
	this.select_random_partname = function(){
		return this.customer_partnames[Math.floor(
				Math.random() * this.customer_partnames.length)]
	}
	for(var i=0; i<1; i++){
		this.add_customer_partname()
	}

	this.make_part_rarer = function(partname){
		this.part_chances[partname] *= 0.9
		console.log(partname+" chance is now "+this.part_chances[partname])
	}
}

function variation(d) {
	return Math.random() * d * 2 - d
}

function add_part_tooltip(game, part) {
	var lib = part_library[part.key.replace(/^part_/, "")]
	part.tip = new Phasetips(game, {
		targetObject: part,
		//context: lib.what + (lib.info?(" - "+lib.info):""),
		context: lib.what + " " + lib.material + "€",
		backgroundColor: 0x222222,
		strokeColor: 0xcb740e,
		position: "right",
		enableCursor: true,
		animation: "grow",
		animationSpeedShow: 1,
		animationSpeedHide: 1,
		textStyle: {
			fontSize: FONT_SIZE,
			fill: "#ffffff",
			stroke: "#1e1e1e",
			strokeThickness: 1,
			wordWrap: true,
			wordWrapWidth: 200
		}
	});
}

function generate_customer() {
	return customer
}

function get_new_customer(game_state) {
	game_state.customer = {}
	game_state.customer.broken_partname = game_state.select_random_partname()
	console.log("Generated game_state.customer claims \""+
			game_state.customer.broken_partname+"\" is broken")
	game_state.current_procedure = []
	game_state.current_material_cost = 0
	game_state.current_work_cost = 0
}

function value_or_default(x, default_value) {
	if(x !== undefined)
		return x
	return default_value
}

function generate_engine_bay(game, base, game_state, missing_partname, opts) {
	var engine_bay = game.add.group()

	var gpac = function(partname){
		var c = game_state.global_part_appearance_chance
		c *= game_state.part_chances[partname]
		return c
	}

	var parts = game.add.group()
	engine_bay.add(parts)
	engine_bay.parts = parts

	engine_bay.valve_cover_group = game.add.group()
	engine_bay.add(engine_bay.valve_cover_group)
	engine_bay.valve_cover = engine_bay.valve_cover_group.create(
		400 + variation(30),
		180 + variation(60),
		"valvecover")

	for(var partname in part_library){
		var lib = part_library[partname]
		if(missing_partname == partname)
			continue
		for(var add_i=0; add_i<value_or_default(lib.max_num, 1); add_i++){
			if(Math.random() >= value_or_default(lib.chance, 0.8) * gpac(partname))
				continue
			var x = undefined
			var y = undefined
			if(lib.x !== undefined){
				x = lib.x + variation(value_or_default(lib.xd, 0))
			}
			if(lib.y !== undefined){
				y = lib.y + variation(value_or_default(lib.yd, 0))
			}
			if(lib.x1 !== undefined && lib.x2 !== undefined){
				if(Math.random() < 0.5)
					x = lib.x1 + variation(value_or_default(lib.x1d, 0))
				else
					x = lib.x2 + variation(value_or_default(lib.x2d, 0))
			}
			if(lib.y1 !== undefined && lib.y2 !== undefined){
				if(Math.random() < 0.5)
					y = lib.y1 + variation(value_or_default(lib.y1d, 0))
				else
					y = lib.y2 + variation(value_or_default(lib.y2d, 0))
			}
			if(x === undefined || y === undefined)
				continue
			if(lib.position_base === "valve_cover"){
				x += engine_bay.valve_cover.position.x
				y += engine_bay.valve_cover.position.y
			} else if(lib.position_base !== undefined){
				console.warn("Unknown position_base: "+lib.position_base)
			}
			parts.create(x, y, "part_"+partname)
		}
	}

	/*if(Math.random() < 0.5){
		var headlight_var = variation(30)
		if(Math.random() < 0.99 * gpac("headlight_left") && missing_partname != "headlight_left")
			parts.create(
				190 + headlight_var,
				540,
				"part_headlight_left")
		if(Math.random() < 0.99 * gpac("headlight_right") && missing_partname != "headlight_right")
			parts.create(
				680 - headlight_var,
				540,
				"part_headlight_right")
	} else {*/
		var headlight_var = variation(30)
		if(Math.random() < 0.995 * gpac("headlight_left2") && missing_partname != "headlight_left2")
			parts.create(
				190 + headlight_var,
				540-32,
				"part_headlight_left2")
		if(Math.random() < 0.99 * gpac("headlight_right2") && missing_partname != "headlight_right2")
			parts.create(
				680 - headlight_var,
				540-32,
				"part_headlight_right2")
	//}

	var shock_dx = variation(30)
	var shock_y = 300 + variation(30)

	if(Math.random() < 0.99 * gpac("shock_absorber_left") && missing_partname != "shock_absorber_left")
		parts.create(
			240 + shock_dx,
			shock_y,
			"part_shock_absorber_left")

	if(Math.random() < 0.99 * gpac("shock_absorber_right") && missing_partname != "shock_absorber_right")
		parts.create(
			630 - shock_dx,
			shock_y,
			"part_shock_absorber_right")

	engine_bay.top_stuff = game.add.group()
	engine_bay.add(engine_bay.top_stuff)
	engine_bay.top_stuff.create(100, 0, "enginebay1")

	// Bring these to top before adding tooltips so that tooltips are on top of
	// these
	//game.world.bringToTop(engine_bay.top_stuff)
	//game.world.bringToTop(engine_bay.valve_cover)
	base.bringToTop(engine_bay.top_stuff)
	base.bringToTop(engine_bay.valve_cover)

	parts.forEach(function(part){
		add_part_tooltip(game, part)
		part.inputEnabled = true
		part.events.onInputOver.add(function(){
			if(!part.removed_by_player)
				part.tint = 0x88ff88
			//console.log(part_library[part.key.replace(/^part_/, "")])
		})
		part.events.onInputOut.add(function(){
			if(!part.removed_by_player)
				part.tint = 0xffffff
		})
		part.events.onInputUp.add(function(){
			console.log("clicked", part)
			opts.on_click_part(part)
		})
	})

	return engine_bay
}
